#include <bits/stdc++.h>
#define MAXN 500007
using namespace std;
int a[MAXN],rl[MAXN];
int main()
{
    int n,k;
    scanf("%d%d",&n,&k);
    for(int i=0;i<n;i++) scanf("%d",&a[i]);
    stack<int> st;
    for(int i=n-1;i>=0;i--)
    {
        while(!st.empty() && a[st.top()]>=a[i]) st.pop();
        if(st.empty()) rl[i]=2*MAXN;
        else rl[i]=st.top();
        st.push(i);
    }
    for(int i=0;i<n;i++)
    {
        if(rl[i]>i+k && i+k!=n) printf("%d ",a[i]);
        else k--;
    }
    return 0;
}